#version 430 core

layout(location=1) in vec3 position;
layout(location=2) in vec3 normal;
layout(location=3) in vec2 texCoords;
layout(location=4) in vec3 color;
layout(location=5) in vec3 tangent;
layout(location=6) in vec3 bitangent;

uniform mat4 world;
uniform mat4 view;
uniform mat4 perspective;
uniform mat3 normalMatrix;

subroutine void shadingSpaceType();
layout(location=0) subroutine uniform shadingSpaceType shadingSpace;

out vec3 vf_viewPosition;
out vec3 vf_worldPosition;
out vec3 vf_normal;
out vec3 vf_color;
out vec2 vf_texCoords;
out vec3 vf_tangent;
out vec3 vf_bitangent;

subroutine(shadingSpaceType)
void shadingSpaceTangent()
{
	vf_tangent = normalMatrix * tangent;
	vf_bitangent = -normalMatrix * bitangent;
}

subroutine(shadingSpaceType)
void shadingSpaceView()
{
}

void main(void)
{
	vec4 worldpos = world * vec4(position.xyz, 1.0);
	vec4 viewpos = view * worldpos;
	gl_Position = perspective * viewpos;
	vf_worldPosition = worldpos.xyz;
	vf_viewPosition = viewpos.xyz;
	vf_normal = normalMatrix * normal;
	shadingSpace();
	vf_color = color;
	vf_texCoords = texCoords;
}