#version 430 core

layout(location=0) in vec4 position;
layout(location=1) in vec2 halfSize;

uniform sampler2DShadow depthMap; // slot 0
uniform mat4 viewProjectionMatrix;
uniform vec4 viewMatrixRow3Negated;
uniform vec2 projectionEntries;

out vec2 vg_size;

void main(void)
{
	gl_Position = viewProjectionMatrix * position;
	vec4 shadowCoord = vec4(gl_Position.xyz*0.5f + gl_Position.w*0.5f, gl_Position.w);
	float visible = textureProj(depthMap, shadowCoord);
	vg_size = gl_Position.w * visible * projectionEntries * halfSize / dot(viewMatrixRow3Negated, position);
}