#version 430 core

layout(location=0) in uint drawID;
layout(location=1) in vec3 position;
layout(location=2) in vec3 normal;
layout(location=3) in vec2 texCoords;
layout(location=5) in vec3 tangent;
layout(location=6) in vec3 bitangent;

subroutine void normalMappingType();
layout(location=0) subroutine uniform normalMappingType normalMapping;

struct MeshInstanceProperties
{
	mat4 worldViewProjectionMatrix;
	mat3 normalMatrix;
	vec4 worldViewMatrix_row3;
	vec3 shininess_objectID_normalMapStrength;
};

//uniform vec4 worldViewMatrix_row3;
//uniform mat4 worldViewProjectionMatrix;
//uniform mat3 normalMatrix;

layout(std430, binding=0) buffer MeshInstancePropertiesBlock
{
	MeshInstanceProperties prop[];
};

out vec4 vf_normal_linearDepth;
out vec3 vf_tangent;
out vec3 vf_bitangent;
out vec2 vf_texCoords;
flat out uint vf_drawID;

subroutine(normalMappingType)
void normalMappingOn()
{
	vf_tangent = prop[drawID].normalMatrix * tangent;
	vf_bitangent = prop[drawID].normalMatrix * bitangent;
}

subroutine(normalMappingType)
void normalMappingOff()
{
}

void main(void)
{
	vec4 position4 = vec4(position, 1.f);
	gl_Position = prop[drawID].worldViewProjectionMatrix * position4;
	vf_texCoords = texCoords;
	vf_normal_linearDepth.xyz = prop[drawID].normalMatrix * normal;
	vf_normal_linearDepth.w = dot(prop[drawID].worldViewMatrix_row3, position4);
	normalMapping();
	vf_drawID = drawID;
}