#version 430 core

layout(location=1) in vec3 position;
layout(location=3) in vec2 texCoords;

uniform mat4 worldViewProjectionMatrix;
uniform mat4 prevWVPMatrix;
uniform mat4 worldMatrix;
uniform vec3 cameraPosition;

out vec2 vf_texCoords;
out vec3 vf_worldPosition;
out vec3 vf_worldViewVector;
out vec4 vf_screenPosition;
out vec4 vf_prevScreenPosition;

void main(void)
{
	vf_screenPosition = worldViewProjectionMatrix * vec4(position, 1.f);
	gl_Position = vf_screenPosition;
	vf_prevScreenPosition = prevWVPMatrix * vec4(position, 1.f);
	vf_worldPosition = vec3(worldMatrix * vec4(position, 1.f));
	vf_worldViewVector = vf_worldPosition - cameraPosition;
	vf_texCoords = texCoords;
}