#version 430 core

#define %shadowing_technique% // either NONE or PCF or PCSS

layout(location=1) in vec3 position;

layout(std140, binding=0) uniform WorldViewProjectionMatrixBlock {
	uniform mat4 worldViewProjectionMatrix[100];
};

uniform int baseInstance;

noperspective out vec2 vf_ndcCoordinates;
flat out int vf_instanceID;
#ifdef PCSS
	flat out int vf_depthConversionID;
#endif

void main(void)
{
	#ifdef PCSS
		vf_depthConversionID = gl_InstanceID;
	#endif
	vf_instanceID = gl_InstanceID + baseInstance;
	gl_Position = worldViewProjectionMatrix[vf_instanceID] * vec4(position, 1.f);
	vf_ndcCoordinates = gl_Position.xy / gl_Position.w;
}