#version 330 core

layout(location=1) in vec3 position;

uniform mat4 lightViewToProjection;
uniform vec4 lightDepthConversion;

uniform vec3 frustumLBN;
uniform vec3 frustumRTF;

uniform sampler2DArray shadowMap;
uniform int shadowMapIndex;

out float lightViewDepth;

void main(void)
{
	float lightDepth = texture(shadowMap, vec3(position.xy, shadowMapIndex)).r;
	lightViewDepth = (lightDepthConversion.x + lightDepthConversion.y * lightDepth) / (lightDepthConversion.z + lightDepthConversion.w * lightDepth);
	vec2 xyMin = mix(frustumLBN.xy, -frustumRTF.xy, lightViewDepth);
	vec2 xy = xyMin * (vec2(1.f,1.f) - 2.f * position.xy);
	vec3 lightViewPosition = vec3(xy, mix(frustumLBN.z, frustumRTF.z, lightViewDepth));
	lightViewPosition = mix(vec3(0.0f), lightViewPosition, position.z);
	gl_Position = lightViewToProjection * vec4(lightViewPosition, 1.0f);
}