#version 430 core

uniform sampler2D colorMap;
uniform sampler2D velocityMap;

uniform vec3 invImageSize_blurScale;

layout(location=0) out vec3 outColor;

void main(void)
{
	//outColor = texelFetch(colorMap, ivec2(gl_FragCoord.xy), 0).xyz;
	//return;

	vec2 velocity = texelFetch(velocityMap, ivec2(gl_FragCoord.xy), 0).xy;
	velocity = (velocity-0.5f)*0.02f*invImageSize_blurScale.z;
	float speed = length(velocity);
	velocity = smoothstep(0.004,0.01,speed) * velocity;
	vec2 texCoords = gl_FragCoord.xy*invImageSize_blurScale.xy - velocity;

	outColor = vec3(0.f);
	vec2 scaledVel = velocity * 2.f / 8.f;
	for (int i=0; i<=8; i++)
	{
		vec2 coords = texCoords + scaledVel * i;
		outColor += texture(colorMap, coords).rgb;
	}

	outColor /= 9.f;
}