#version 430 core

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D lensFlareDirtTexture;
uniform sampler2D starBurstTexture;
uniform mat3 starBurstMatrix;

uniform vec3 overlayColor;

in vec2 vf_texCoords;
in float vf_avgLuminance;

out vec4 outColor;

void main(void)
{
	vec2 burstCoords = (starBurstMatrix * vec3(vf_texCoords, 1.f)).xy;
	vec3 lensflare = texture(texture1, vf_texCoords).xyz * (texture(lensFlareDirtTexture, vf_texCoords).rrr + texture(starBurstTexture, burstCoords).rrr);
	vec3 rgb = texture(texture0, vf_texCoords).xyz + lensflare;
	float lum = dot(rgb, vec3(0.2126f, 0.7152f, 0.0722f));
	float newLum = lum * 0.46f / vf_avgLuminance;
	//float lum = sqrt(rgb.r * rgb.r * .241 + rgb.g * rgb.g * .691 + rgb.b * rgb.b * .068);
	//float scale = ( 1 + (lum / (2.f*2.f)) ) / (1 + lum);
	float scale = newLum / (lum*(1.f+newLum));
	outColor = vec4(rgb*scale*overlayColor, 1.f),0.0f;
	
	/*outColor = vec4(rgb, 1.f);
	float l= 0.5f;
	if(rgb.r<=l && rgb.g<=l && rgb.b<=l){
		outColor.r=0.0f;
		outColor.g=0.0f;
		outColor.b=0.0f;
	}*/
	//outColor = vec4(rgb, 1.f);
}