#version 430 core

in vec3 viewDirection;

uniform sampler2D environmentMap;

out vec3 outColor;

void main(void)
{
	float azimuth = atan(viewDirection.z, viewDirection.x);
	float xz_length = sqrt(viewDirection.z*viewDirection.z + viewDirection.x*viewDirection.x);
	float altitude = atan(viewDirection.y / xz_length);
	vec3 color = texture(environmentMap, 0.5f+vec2(azimuth/6.283185f, altitude/3.1415926f)).xyz;
	outColor = color;
}