#version 430 core

layout (local_size_x = 512, local_size_y = 1, local_size_z = 1) in;

uniform uint count;

struct CollisionConstraint
{
	vec4 q_active;
	vec4 n; //w inactive
};

layout(std430, binding=1) buffer positionEstimates {
	coherent vec4 p[];
};

layout(std430, binding=5) buffer collisionConstraints {
	CollisionConstraint constraint[];
};

void main(void)
{
	uint gid = gl_GlobalInvocationID.x;
	if (gid < count)
	{
		vec3 position = p[gid].xyz;
		for (int i=0;i<2;i++)
		{
			if (constraint[2*gid+i].q_active.w == 1.0f)
			{
				vec3 q = constraint[2*gid+i].q_active.xyz;
				vec3 n = constraint[2*gid+i].n.xyz;

				vec3 delta_p = -n*min(0.f, dot(position-q, n));
				position += delta_p;
				p[gid].xyz = position;
			}
		}
	}
}