#version 430 core

layout(vertices = 3) out;

in vec3 c_position[];
in vec3 c_normal[];
in vec2 c_texCoords[];
in vec3 c_tangentLightVector[];
in vec3 c_tangentViewVector[];
in float c_distance[];

out vec3 e_position[];
out vec3 e_normal[];
out vec2 e_texCoords[];
out vec3 e_tangentLightVector[];
out vec3 e_tangentViewVector[];

void main(void)
{
	e_position[gl_InvocationID] = c_position[gl_InvocationID];
	e_normal[gl_InvocationID] = c_normal[gl_InvocationID];
	e_texCoords[gl_InvocationID] = c_texCoords[gl_InvocationID];
	e_tangentLightVector[gl_InvocationID] = c_tangentLightVector[gl_InvocationID];
	e_tangentViewVector[gl_InvocationID] = c_tangentViewVector[gl_InvocationID];

	
	if (gl_InvocationID == 0)
	{
		float edgeDistance0 = mix(c_distance[1], c_distance[2], 0.5f);
		float edgeDistance1 = mix(c_distance[2], c_distance[0], 0.5f);
		float edgeDistance2 = mix(c_distance[0], c_distance[1], 0.5f);
		gl_TessLevelOuter[0] = clamp(100.f / edgeDistance0, 1, 10);
		gl_TessLevelOuter[1] = clamp(100.f / edgeDistance1, 1, 10);
		gl_TessLevelOuter[2] = clamp(100.f / edgeDistance2, 1, 10);
		//gl_TessLevelOuter[0] = 10;
		//gl_TessLevelOuter[1] = 10;
		//gl_TessLevelOuter[2] = 10;
		gl_TessLevelInner[0] = gl_TessLevelOuter[0];
	}
}