#version 430 core

layout(location=1) in vec3 position;
layout(location=2) in vec3 normal;
layout(location=3) in vec2 texCoords;
layout(location=5) in vec3 tangent;
layout(location=6) in vec3 bitangent;

uniform vec3 lightPosition;
uniform vec3 cameraPosition;

out vec3 c_position;
out vec3 c_normal;
out vec2 c_texCoords;
out vec3 c_tangentLightVector;
out vec3 c_tangentViewVector;
out float c_distance;

void main(void)
{
	c_position = position;
	c_normal = normal;
	c_texCoords = texCoords;

	c_tangentLightVector = lightPosition - position;
	c_tangentLightVector = vec3(
		dot(tangent, c_tangentLightVector),
		dot(bitangent, c_tangentLightVector),
		dot(normal, c_tangentLightVector)
	);

	c_tangentViewVector = position - cameraPosition;
	c_distance = length(c_tangentViewVector);
	c_tangentViewVector = vec3(
		dot(tangent, c_tangentViewVector),
		dot(bitangent, c_tangentViewVector),
		dot(normal, c_tangentViewVector)
	);

}