#version 430 core

layout(points) in;
layout(triangle_strip, max_vertices=4) out;

uniform mat4 viewProjectionMatrix;
uniform vec4 upVector;
uniform vec4 sideVector;

in vec4 vg_halfSize_frame[1];

out vec3 gf_texCoords;

void main(void)
{
	vec4 right = sideVector * vg_halfSize_frame[0].x;
	vec4 up = upVector * vg_halfSize_frame[0].y;
	float frame = vg_halfSize_frame[0].z;

	gl_Position = viewProjectionMatrix * (gl_in[0].gl_Position - right);
	gf_texCoords = vec3(0.f,0.f,frame);
	EmitVertex();

	gl_Position = viewProjectionMatrix * (gl_in[0].gl_Position + right);
	gf_texCoords = vec3(1.f, 0.f,frame);
	EmitVertex();

	gl_Position = viewProjectionMatrix * (gl_in[0].gl_Position - right + up);
	gf_texCoords = vec3(0.f, 1.f,frame);
	EmitVertex();

	gl_Position = viewProjectionMatrix * (gl_in[0].gl_Position + right + up);
	gf_texCoords = vec3(1.f,1.f,frame);
	EmitVertex();
}