#version 330 core


uniform sampler2D depthMap; // slot 0
uniform sampler2D ssaoMap; // slot 1

out vec3 ambientOcclusion;

void main(void)
{
	float blurred = 0.0f;
	float depthCenter = -texelFetch(depthMap, ivec2(gl_FragCoord.xy),0).x;
	float wTotal = 0.0f;
	for (int i=-2;i<=1;i++)
	{
		ivec2 coord = ivec2(gl_FragCoord.xy) + ivec2(0,i);
		float depth = -texelFetch(depthMap, coord,0).x;
		float dDiff = depth - depthCenter;
		float w = exp(-i*i*0.08 - dDiff*dDiff*8.f);
		wTotal += w;
		blurred += w*texelFetch(ssaoMap, coord, 0).r;
	}
	blurred /= wTotal;

	ambientOcclusion = vec3(blurred,blurred,blurred);
}