#version 430 core

uniform mat4 perspective;
uniform mat4 worldView;
uniform mat3 normalMatrix;

layout(location=1) in vec3 position;
layout(location=2) in vec3 normal;
layout(location=5) in vec3 tangent;
layout(location=6) in vec3 bitangent;

out vec3 mvNormal;
out vec3 mvTangent;
out vec3 mvBitangent;
out vec3 mvPosition;

void main(void)
{
	mvPosition = (worldView * vec4(position,1.0f)).xyz;
	mvNormal = normalMatrix * normal;
	mvTangent = normalMatrix * tangent;
	mvBitangent = normalMatrix * bitangent;
	gl_Position = perspective * vec4(mvPosition,1.0f);
}